<?php

class Createview extends CI_Controller{

    public function __construct()
    {
      parent::__construct();
      if($this->session->userdata('loggedin') !== '1')
      {
        redirect('main','location');
      }
      $this->load->library(array('table','pagination'));
      $this->load->model('createviewmodel');

      set_time_limit(0);
      ini_set('memory_limit', '-1');
    }

    public function create($currentCall = "")
    {
      set_time_limit(0);

      $data['table'] =  "";

      $this->load->model('authmodel');
      $userDB = $this->authmodel->getDBName();

      $this->load->model('createviewmodel');
      $dbName = $this->createviewmodel->getDBName();

      $currentSPRunningQ = $this->createviewmodel->getProcessStatus($userDB, $dbName);

      if($currentSPRunningQ->num_rows() > 0){
         $row = $currentSPRunningQ->row();
         $state = $row->STATE;
         $time = $row->TIME;
         $info = $row->INFO;
         $refreshButton = '<a href="'.base_url().'index.php/createview/create'.'"><button title="Refresh Status" type="button" onclick="location.href=">Refresh Status</button></a>';
         $status = "<b>A stored procedure is currently running. Please wait while it's done.</b><br />
                    <b>State:</b> ".$state
                    ."<br /><b>Run Time:</b> ".$time."s"
                    ."<br /><b>Current Query:</b> <p style='text-align:left; font-size:9px; background-color:#e4e4e4;'>".$info."</p>"
                    ."<br /><b>Refresh to check status:</b> ".$refreshButton;
        $data['table'] = $data['table']."<br /><br />".$status;
      } elseif($currentCall == 'viewtaxonomy'){
        $this->createviewmodel->callSPTaxonomy($userDB,$dbName);
        redirect(base_url().'index.php/createview/create');
      } elseif($currentCall == 'viewfull'){
        $this->createviewmodel->callSPViewFull($userDB,$dbName);
        redirect(base_url().'index.php/createview/create');
      }
      else {
        $data['table'] = "<h5>Create View Tables - Execute One Stored Procedure At A Time</h5>";
        $vTaxTable = "<h5>Create ViewTaxonomy</h5>";
        $vTaxName = "ViewTaxonomy";
        $vTaxStatusR = $this->createviewmodel->getTableStatus($dbName,$vTaxName);
        if($vTaxStatusR->num_rows() > 0){
          $row = $vTaxStatusR->row();
          $createTime = $row->CREATE_TIME;
          $updateTime = $row->UPDATE_TIME;
          $tblRows = $row->TABLE_ROWS;

          $createButton = '<a href="'.base_url().'index.php/createview/create/viewtaxonomy'.'"><button title="Recreate ViewTaxonomy" type="button" onclick="location.href=">Recreate ViewTaxonomy</button></a>';

          $vTaxTable = $vTaxTable
                       ."<b>Created On:</b> ".$createTime
                       ."<br /><b>Updated On</b>: ".$updateTime
                       ."<br /><b>Records:</b> ".$tblRows
                       ."<br />".$createButton;
        }
        else {
          $createButton = '<a href="'.base_url().'index.php/createview/create/viewtaxonomy'.'"><button title="Create ViewTaxonomy" type="button" onclick="location.href=">Create ViewTaxonomy</button></a>';
          $vTaxTable = $vTaxTable."ViewTaxonomy doesn't exist - ".$createButton;
        }


        $vFullTable = "<h5>Create ViewFullTable</h5>";
        $vFullName = "ViewFullTable";
        $vFullStatusR = $this->createviewmodel->getTableStatus($dbName,$vFullName);
        if($vFullStatusR->num_rows() > 0){
          $row = $vFullStatusR->row();
          $createTime = $row->CREATE_TIME;
          $updateTime = $row->UPDATE_TIME;
          $tblRows = $row->TABLE_ROWS;

          $createButton = '<a href="'.base_url().'index.php/createview/create/viewfull'.'"><button title="Recreate ViewFullTable" type="button" onclick="location.href=">Recreate ViewFullTable</button></a>';

          $vFullTable = $vFullTable
                       ."<b>Created On:</b> ".$createTime
                       ."<br /><b>Updated On</b>: ".$updateTime
                       ."<br /><b>Records:</b> ".$tblRows
                       ."<br />".$createButton;
        }
        else {
          $createButton = '<a href="'.base_url().'index.php/createview/create/viewfull'.'"><button title="Create ViewFullTable" type="button" onclick="location.href=">Create ViewFullTable</button></a>';
          $vFullTable = $vFullTable."ViewFullTable doesn't exist - ".$createButton;
        }


        $data['table'] = $data['table']."<br /><br />".$vTaxTable."<br /><br />".$vFullTable;
      }




      $plotCensusArray = $this->session->userdata('plotCensusArray');
      $plotName = $plotCensusArray['plotName'];
      $censusNumber = $plotCensusArray['censusNumber'];
      $plotActualName = $plotCensusArray['plotActualName'];
      $data['title'] = 'CTFS/SIGEO Forest Plot Census Data';
      $data['contentTitle'] = 'Create View Tables - <span style="font-size:.7em;"> Plot Name: <span style="color:#8C0209;">'.ucfirst($plotActualName).'</span>, Census Number: <span style="color:#8C0209">'.$censusNumber.'</span></span>';

      $this->load->view('upload/createview',$data);
    }

////////////Populate PX and PY///////////////////////
    public function PopPXPY()
    {
      // zero the quadrat QX,QY fields in the Coordinates table
      // zero the plot PX,PY fields in the Coordinates table
      $this->createviewmodel->PopPXPY1();

      // calculating plot-local points (in Stem table) from quadrat points (in Coordinates table)
      // calculating plot-local points for features (in Coordinates table) from quadrat points (in Coordinates table)
      $this->createviewmodel->PopPXPY2();

      echo '<span class="smallsuccess">PX and PY Populated.</span>';
    }
/////////End - Populate PX and PY///////////////////

/////////Steps to create ViewFullTable///////////////

    public function SGFtemp()
    {
      // Plot Records
      // Table structure for table `SGFtemp`

      $this->createviewmodel->SGFTemp();
      echo '<span class="smallsuccess">SGFtemp Created.</span>';
    }

    public function MPQTtemp()
    {
      // Plot Records report
      // Table structure for table MPQTtemp

      $this->createviewmodel->MPQTtemp();
      echo '<span class="smallsuccess">MPQTtemp Created.</span>';
    }

    public function ViewFullTable()
    {
      // Table structure for table ViewFullTable: the primary temporary table housing all measurements of every stem in every census, joined to species name,
      // plot name, and census number (ie, all in one table). It is built using the previous 2 tables, which are now (Oct 2008) dropped after this table is
      // finished

      $this->createviewmodel->viewFullTable();
      //$this->createviewmodel->viewFullTable2();
      echo '<span class="smallsuccess">ViewFullTable Created.</span>';
    }

    /*public function updListOfTSM()
    {
       // The following restrict the query to measurements where there is an attribute. This is often well below half of measurements
      $dbhQuery = $this->createviewmodel->getDBHData();

      if($dbhQuery->num_rows() > 0)
      {
        foreach($dbhQuery->result_array() as $dbhRow)
        {
          $dbhID = trim($dbhRow['DBHID']);
          //$censusID = trim($dbhRow['CensusID']);

          $tsmQuery = $this->createviewmodel->getTSMData($dbhID);

          $listOfTSM = '';
          $firstTime = 0;

          if($tsmQuery->num_rows() > 0)
          {
            foreach($tsmQuery->result_array() as $tsmRow)
            {
              $tsmCode = trim($tsmRow['TSMCode']);
              if($firstTime == 0)
              {
            	$listOfTSM = $tsmCode;
                $firstTime = 1;
              }
              else
              {
            	$listOfTSM = $listOfTSM.",".$tsmCode;
              }
            }

            $this->createviewmodel->updVFTListOfTSM($dbhID,$listOfTSM);
          }
        }
      }
      echo '<span class="smallsuccess">ListOfTSM Updated in ViewFullTable.</span>';
    }*/

    public function updListOfTSM()
    {
       // The following restrict the query to measurements where there is an attribute. This is often well below half of measurements
      $dbhQuery = $this->createviewmodel->getDBHData();

      //Get the dead and lost stem TSMcodes from the table
	  $deadcode=$this->createviewmodel->getCodes2('dead');
	  $brokenBelowCode=$this->createviewmodel->getCodes2('broken below');
	  $notFoundCode = $this->createviewmodel->getCodes2('not found');
      $notMeasuredCode = $this->createviewmodel->getCodes2('alive-not measured');


      if($dbhQuery->num_rows() > 0)
      {
        foreach($dbhQuery->result_array() as $dbhRow)
        {
          $status = 'alive';
          $dbhID = trim($dbhRow['DBHID']);
          //$censusID = trim($dbhRow['CensusID']);

          $tsmQuery = $this->createviewmodel->getTSMData($dbhID);

          $listOfTSM = '';
          $firstTime = 0;

          if($tsmQuery->num_rows() > 0)
          {
            foreach($tsmQuery->result_array() as $tsmRow)
            {
              $tsmCode = trim($tsmRow['TSMCode']);
              if($firstTime == 0)
              {
            	$listOfTSM = $tsmCode;
                $firstTime = 1;

              }
              else
              {
            	$listOfTSM = $listOfTSM.",".$tsmCode;
              }
              if(in_array($tsmCode,$deadcode)) {
                $status = 'dead';
              }
              else if($status !== 'dead' AND in_array($tsmCode,$brokenBelowCode)) {
                $status = 'broken below';
              }
              else if($status !== 'dead' AND $status !== 'broken below' AND in_array($tsmCode,$notFoundCode)) {
                $status = 'not found';
              }
              else if($status !== 'dead' AND $status !== 'broken below' AND $status !== 'not found' AND in_array($tsmCode,$notMeasuredCode)) {
                $status = 'alive-not measured';
              }
            }
            $this->createviewmodel->updVFTListOfTSM2($dbhID,$listOfTSM,$status);
          }
        }
        $this->createviewmodel->updNullStatus();
      }
      echo '<span class="smallsuccess">ListOfTSM Updated in ViewFullTable.</span>';
    }

    public function finish() {
       echo '<span class="smallsuccess">END</span>';
    }



    public function updStatus()
    {
      //Calculate status field for each ViewFullTable record
      $this->createviewmodel->updStatus2();
      echo '<span class="smallsuccess">Status Updated in ViewFullTable.</span>';
    }
/////////////End - Steps to create ViewFullTable ////////////////


/////////////Steps to Create Taxonomy Views//////////////////

    public function TAX1temp()
    {
      // This creates a table called TAX1temp which has all species in CurrentTaxonomyTable, collecting subspecies and
      // adding a variable for all old names
      // Table structure for table `TAX1temp`
      $this->createviewmodel->tax1temp();
      echo '<span class="smallsuccess">ViewTaxonomy Created.</span>';
    }

    public function TAX2temp()
    {
      // This creates a table called TAX2temp with all obsolete species names along with the current name of each
      // Table structure for table `TAX2temp`
      $this->createviewmodel->tax2temp();
      echo '<span class="smallsuccess">TAX2temp Created.</span>';
    }

    public function TAX3temp()
    {
      // This creates a table called TAX3temp which collects every current species name with every plot
      // or inventory the species is known from. It queries both PlotInventory and TreeTaxonomy tables.
      // Table structure for table `TAX3temp`
      $this->createviewmodel->tax3temp();
      echo '<span class="smallsuccess">TAX3temp Created.</span>';
    }

    public function concatspecies1()
    {
      $getSpecies = $this->createviewmodel->getSpeciesIDs();
      if($getSpecies->num_rows() > 0)
      {
        foreach($getSpecies->result_array() as $speciesRow)
        {
          $speciesID = trim($speciesRow['SpeciesID']);
          $numberOfHerbarium = 0;
      	  $listOfHerbarium = '';
      	  $firstTime = 0;

          $getHerbarium = $this->createviewmodel->getHerbarium($speciesID);
          $numberOfHerbarium = $getHerbarium->num_rows();
          if($numberOfHerbarium > 0)
          {
            foreach($getHerbarium->result_array() as $herbariumRow)
            {
              $herbarium = trim($herbariumRow['Herbarium']);
              if($firstTime == 0)
              {
                $listOfHerbarium = $herbarium;
               	$firstTime = 1;
              }
              else
              {
                $listOfHerbarium = $listOfHerbarium.",".$herbarium;
              }
            }
            $this->createviewmodel->updListOfHerbarium($speciesID,$numberOfHerbarium,$listOfHerbarium);
          }
        }
      }
      echo '<span class="smallsuccess">List Of Herbarium Updated in ViewTaxonomy.</span>';
    }

    public function concatspecies2()
    {
      $getSpecies = $this->createviewmodel->getSpeciesIDs();
      if($getSpecies->num_rows() > 0)
      {
        foreach($getSpecies->result_array() as $speciesRow)
        {
          $speciesID = trim($speciesRow['SpeciesID']);
          $startingSpeciesID = $speciesID;
      	  $listOfOldNames = '';
      	  $firstTime = 0;
      	  $head = 0;
      	  $tail = 0;
      	  $queue = '';

          //ExpandSpecie
          $getSpeciesData = $this->createviewmodel->getSpeciesData($speciesID);
          if($getSpeciesData->num_rows() > 0)
          {
            $rowSpecies['SpeciesName'] = '';
            foreach($getSpeciesData->result_array() as $rowSpecies)
            {
              $speciesName = trim($rowSpecies['SpeciesName'],"'");
			  $rowSpecies['SpeciesName'] = '';
			  $genusID = trim($rowSpecies['GenusID'],"'");

              $getGenus = $this->createviewmodel->getGenus($genusID);
              $rowGenus = $getGenus->row_array();
              $genusName = trim($rowGenus['Genus'],"'");

              if($firstTime == 0)
              {
                $listOfOldNames = $genusName." ".$speciesName;
                $firstTime = 1;
              }
              else
              {
                $listOfOldNames = $listOfOldNames.",".$genusName." ".$speciesName;
              }
              // Build Queue
			  $obsoleteSpeciesID = trim($rowSpecies['ObsoleteSpeciesID'],"'");
			  $queue[$tail] = $obsoleteSpeciesID;
			  $tail = $tail + 1;
            }
          }
          /////////////////////
          while (($head < $tail) AND ($tail != 0))
	      {
	        // pop top ObsoleteSpeciesID and make CO.SpeciesID
		    $speciesID = $queue[$head];
		    $head = $head + 1;

            //ExpandSpecie
            $getSpeciesData = $this->createviewmodel->getSpeciesData($speciesID);
            if($getSpeciesData->num_rows() > 0)
            {
              $rowSpecies['SpeciesName'] = '';
              foreach($getSpeciesData->result_array() as $rowSpecies)
              {
                $speciesName = trim($rowSpecies['SpeciesName'],"'");
  			  $rowSpecies['SpeciesName'] = '';
  			  $genusID = trim($rowSpecies['GenusID'],"'");

                $getGenus = $this->createviewmodel->getGenus($genusID);
                $rowGenus = $getGenus->row_array();
                $genusName = trim($rowGenus['Genus'],"'");

                if($firstTime == 0)
                {
                  $listOfOldNames = $genusName." ".$speciesName;
                  $firstTime = 1;
                }
                else
                {
                  $listOfOldNames = $listOfOldNames.",".$genusName." ".$speciesName;
                }
                // Build Queue
  			  $obsoleteSpeciesID = trim($rowSpecies['ObsoleteSpeciesID'],"'");
  			  $queue[$tail] = $obsoleteSpeciesID;
  			  $tail = $tail + 1;
              }
            }
            /////////////////////
          }
          //update the ViewTaxonomy table with ListOfOldNames
          $this->createviewmodel->updTax1temp($listOfOldNames,$startingSpeciesID);
        }
      }
      echo '<span class="smallsuccess">Old Names Updated in ViewTaxonomy.</span>';
    }

    public function concattemp2()
    {
      $getTAX2temp = $this->createviewmodel->getTAX2temp();

      if($getTAX2temp->num_rows() > 0)
      {
        foreach($getTAX2temp->result_array() as $rowTAX2temp)
        {
          $speciesID = $rowTAX2temp['SpeciesID'];
	      $obsoleteSpeciesID = $rowTAX2temp['ObsoleteSpeciesID'];
	      $obsoleteSpeciesName = trim($rowTAX2temp['ObsoleteSpeciesName']);
	      $obsoleteSpeciesName = addslashes($obsoleteSpeciesName);

          $getGenus = $this->createviewmodel->getGenusName($obsoleteSpeciesID);
          $rowGenus = $getGenus->row_array();
          $oldGenusName = trim($rowGenus['Genus']);
          $oldGenusName = addslashes($oldGenusName);

          // update the TAX2temp table with Old Genus Name
          $this->createviewmodel->updTax2temp($oldGenusName,$obsoleteSpeciesName,$speciesID,$obsoleteSpeciesID);
        }
      }
      echo '<span class="smallsuccess">Old Genus Names Updated in ViewTaxonomy.</span>';
    }

/////////////END - Steps to Create Taxonomy Views//////////////////
    public function test()
    {
      echo "hello";
    }
}
