<?php

class Doublescreeningmodel extends CI_Model{

    public function __construct()
    {
      parent::__construct();
      $database = $this->session->userdata('databaseName');
      $this->dscreeningdb = $this->load->database($database,TRUE);
    }


    public function tableNameList($like)
    {
      $columnName = "Tables_in_".$this->dscreeningdb->database." (".$like.")";
      $query = "SHOW TABLES LIKE '".$like."'";
      $runQ = $this->dscreeningdb->query($query);
      $list = array();
      $list['default'] = 'Select';
      if($runQ->num_rows() > 0)
      {
        foreach($runQ->result_array() as $row)
        {
          $tableName = $row[$columnName];
          $check = $this->_checkIfTableHasData($tableName);
          if($check == "yes")
          {
            $tableNameSplit = explode("_",$tableName);
            if($like == 'TempBigTrees%') {
              if(isset($tableNameSplit[0]) AND isset($tableNameSplit[1]))
              {
                $table1 = $tableName;
                $list[$table1] = $table1;
              }
            }
            else{
              if(isset($tableNameSplit[0]) AND isset($tableNameSplit[2]))
              {
                //$table1 = $tableNameSplit[0]."_1_".$tableNameSplit[2];
                //$table2 = $tableNameSplit[0]."_2_".$tableNameSplit[2];
                $table1 = $tableName;
                $list[$table1] = $table1;
                //$list[$table2] = $table2;
              }
            }

          }
        }
      }
      return $list;
    }

    public function _checkIfTableHasData($tableName)
    {
      $this->dscreeningdb->select('*');
      $query = $this->dscreeningdb->get($tableName);
      if($query->num_rows() > 0)
      {
         $check = "yes";
      }
      else
      {
         $check = "no";
      }
      return $check;
    }

    public function dropAllEmptyScreeningTables($like)
    {
      $columnName = "Tables_in_".$this->dscreeningdb->database." (".$like.")";
      $query = "SHOW TABLES LIKE '".$like."'";
      $runQ = $this->dscreeningdb->query($query);
      $list = array();
      if($runQ->num_rows() > 0)
      {
        foreach($runQ->result_array() as $row)
        {
          $tableName = $row[$columnName];
          $check = $this->_checkIfTableHasData($tableName);
          $tableNameSplit = explode("_",$tableName);
          if(isset($tableNameSplit[0]) AND isset($tableNameSplit[2]))
          {
            $list[$tableName] = $tableName;
            if($check == "yes")
            {
              $table1 = $tableNameSplit[0]."_1_".$tableNameSplit[2];
              $table2 = $tableNameSplit[0]."_2_".$tableNameSplit[2];
              if(isset($list[$table1]) || isset($list[$table2]))
              {
                unset($list[$table1]);
                unset($list[$table2]);
              }
            }
          }
        }
      }
      foreach($list as $key=>$value)
      {
        $this->_dropTable($key);
      }
    }

    public function getPlotNameByID($plotID)
    {
      $this->dscreeningdb->select('PlotName');
      $this->dscreeningdb->where('PlotID',$plotID);
      $query = $this->dscreeningdb->get('Site');
      $row = $query->row();
      $plotName = $row->PlotName;
      return $plotName;
    }

    public function fetchAllRecords($tableName)
    {
      $this->dscreeningdb->select('*');
      $this->dscreeningdb->from($tableName);
      $this->dscreeningdb->order_by('TempID');
      $query = $this->dscreeningdb->get();
      return $query;
    }

    public function fetchCompareRecord($tableName,$tag,$stemTag)
    {
      $this->dscreeningdb->select('*');
      $this->dscreeningdb->where('Tag',$tag);
      $this->dscreeningdb->where('StemTag',$stemTag);
      $query = $this->dscreeningdb->get($tableName);
      return $query;
    }

    public function fetchCompareRecordNoStemTag($tableName,$tag)
    {
      $this->dscreeningdb->select('*');
      $this->dscreeningdb->where('Tag',$tag);
      $query = $this->dscreeningdb->get($tableName);
      return $query;
    }

    public function fetchRecordByTempID($tableName,$tempID)
    {
      $this->dscreeningdb->select('*');
      $this->dscreeningdb->where('TempID',$tempID);
      $query = $this->dscreeningdb->get($tableName);
      return $query;
    }

    public function insertRowIntoTable($tableName,$insertArray)
    {
      $query = $this->dscreeningdb->insert($tableName,$insertArray);
      return $query;
    }

    public function deleteTempRecord($tableName,$tempID)
    {
      $this->dscreeningdb->where('TempID',$tempID);
      $this->dscreeningdb->delete($tableName);
    }

    public function getNextTempID($tableName)
    {
      $this->dscreeningdb->select_max('TempID');
      $query = $this->dscreeningdb->get($tableName);
      $row = $query->row();
      $nextTempID = $row->TempID + 1;
      return $nextTempID;
    }

    public function updataTempID($tableName,$tempID,$newTempID)
    {
      $updateA = array('TempID'=>$newTempID);
      $this->dscreeningdb->where('TempID',$tempID);
      $this->dscreeningdb->update($tableName,$updateA);
    }

    public function _dropTable($tableName)
    {
      $q1 = $this->dscreeningdb->query("DROP TABLE IF EXISTS ".$tableName);
    }

    public function startTransaction()
    {
      $this->dscreeningdb->trans_start();
    }

    public function completeTransaction()
    {
      $this->dscreeningdb->trans_complete();
      $status = 'Success';
      if ($this->dscreeningdb->trans_status() === FALSE)
      {
        $status = 'Error';
      }
      return $status;
    }
}
